declare module 'react-native-metrica' {
  export interface MetricaPreloadInfo {
    trackingId?: string;
    additionalInfo?: Record<string, any>;
  }

  export interface MetricaLocation {
    latitude?: number;
    longitude?: number;
    altitude?: number;
    accuracy?: number;
    verticalAccuracy?: number;
    course?: number;
    speed?: number;
    timestamp?: number;
  }

  export interface MetricaConfig {
    apiKey: string;
    handleFirstActivationAsUpdateEnabled?: boolean;
    trackLocationEnabled?: boolean;
    loggingEnabled?: boolean;
    sessionTimeout?: number;
    appVersion?: string;
    location?: MetricaLocation;
    preloadInfo?: MetricaPreloadInfo;
    // reportCrashesEnabled?: boolean;
  }


  interface RNMetrica {
    activate: (config: MetricaConfig) => void;
    isActivated: () => Promise<boolean>;
    handleOpenURL: (url: string) => void;
    reportEvent: (name: string, params?: Record<string, any>, onError?: (e: any) => void) => void;
    reportError: (name: string, reason?: string, onError?: (e: any) => void) => void;
    setCustomAppVersion: (version: string) => void;
    setLocation: (location: MetricaLocation) => void;
    setTrackLocationEnabled: (enabled: boolean) => void;
    setEnvironmentValue: (key: string, value: string) => void;
    setSessionTimeout: (value: number) => void;
    setLoggingEnabled: () => void;
  }

  const metrica: RNMetrica;

  export default metrica;
}
